routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CheckOutController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\HistoryController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\TransactionController;
use App\Http\Controllers\TransactionsController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/home', function () {
    return view('home');
})->middleware('auth')->name('home');

Route::get('/', [CustomerController::class, 'index'])->name('customer');
Route::get('list-product/{product}', [CustomerController::class, 'listProduct'])->name('listproduct.show');
Route::get('list-detail-product/{product}/{category}', [CustomerController::class, 'listDetailProduct'])->name('listdetailproduct.show');
Route::get('login', [AuthController::class, 'login'])->name('login');
Route::post('login', [AuthController::class, 'logon'])->name('logon');
Route::get('logout', [AuthController::class, 'logout'])->name('logout');
Route::get('register', [UserController::class, 'register'])->name('register');
Route::get('forgot-password', [AuthController::class, 'forgotPassword'])->name('forgot.Password');
Route::get('email', [AuthController::class, 'checkMail'])->name('checkMail');
Route::put('Change-password', [AuthController::class, 'changePassword'])->name('change.Password');

Route::group(['prefix' => 'user', 'middleware' => ['auth', 'role:'.role_user]], function () {
    Route::get('/', [HomeController::class, 'index']);
    Route::get('cart', [CartController::class, 'index'])->name('cart.index');
    Route::post('cart-store', [CartController::class, 'addcart'])->name('cart.store');
    Route::delete('cart-delete/{cart}', [CartController::class, 'destroy'])->name('cart.delete');
    Route::get('history', [HistoryController::class, 'index'])->name('history.index');
    Route::post('checkout', [CheckOutController::class, 'payment'])->name('payment');
    Route::get('payment', [CheckOutController::class, 'returnPayment'])->name('return.payment');
    Route::get('history/{history}', [HistoryController::class, 'detail'])->name('history.detail');
    Route::resource('transactions', TransactionController::class);
});

Route::group(['prefix' => 'admin', 'middleware' => ['auth', 'role:'.role_admin]], function () {

    Route::get('add-user', [UserController::class, 'addUser'])->name('add.user');
    Route::get('restore/{restore}', [CategoryController::class, 'restore'])->name('category.restore');
    Route::resource('categories', CategoryController::class);
    Route::get('listSoftDelete', [CategoryController::class, 'listSoftDelete'])->name('list.categorysoftDelete');
    Route::delete('realdelete/{realdelete}', [CategoryController::class, 'realDelete'])->name('category.realDelete');
    Route::resource('users', UserController::class);
});
Route::group(['prefix' => 'shop', 'middleware' => ['auth', 'role:'.role_shop]], function () {
    Route::get('productSoftDelete', [ProductController::class, 'listSoftDelete'])->name('product.softDelete');
    Route::get('restore/{restore}', [ProductController::class, 'restore'])->name('product.restore');
    Route::delete('realdelete/{realdelete}', [ProductController::class, 'realDelete'])->name('product.realDelete');
    Route::get('order', [OrderController::class, 'index'])->name('order.index');
    Route::put('order/{order}', [OrderController::class, 'update'])->name('order.update');
    Route::post('product-discount', [ProductController::class, 'updateDiscount'])->name('product.updateDiscount');
    Route::resource('products', ProductController::class);
});
Route::resource('users', UserController::class)->only('store');

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Category extends Model
{
    use HasFactory,SoftDeletes;
    const PAGINATION=10;
    protected $fillable=[
        'name',
        'image',
    ];
    public function products(){
        return $this->hasMany(Product::class,'category_id','id');
    }
    public function whereCategory($id){
        return $this->where('id',$id);
    }
    public function scopeSearch($query){
        if($key=request()->key){

            $key=request()->key;
            $query=$query->where('name','LIKE','%'.$key.'%');
        }
        return$query;
    }
    public function list()
    {
        $categories = Static::search()->paginate(self::PAGINATION);
        return $categories;
    }
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CategoryRequest;
use App\Models\Category;

use Illuminate\Http\Request;
use Psy\Readline\Hoa\FileLink;

class CategoryController extends Controller
{
    private $category;
    public function __construct(Category $category)
    {
        $this->category = $category;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = $this->category->all();
        return view('categories.index')->with('categories', $categories);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {

        return view('categories.createorupdate');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CategoryRequest $request)
    {
        if ($request->has('image_link')) {
            $file = $request->image_link;
            $ext = $request->image_link->extension();
            $file_name = time() . "-" . "category." . $ext;
            $file->move(public_path('uploads'), $file_name);
        }
        $request->merge(['image' => $file_name]);
        $this->category->create($request->only(['name', 'image']));
        return redirect()->route('categories.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function show(Category $category)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function edit(Category $category)
    {
        return view('categories.createorupdate')->with('category', $category);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function update(CategoryRequest $request, Category $category)
    {

        if ($request->hasfile('image_link')) {
            $file = $request->image_link;
            $ext = $request->image_link->extension();
            $file_name = time() . "-" . "category." . $ext;
            $file->move(public_path('uploads'), $file_name);
            unlink(public_path('uploads/'."$category->image"));
            $this->category->find($category->id)->update([
                'name' => $request->name,
                'image' => $file_name
            ]);
        } else {
            $this->category->find($category->id)->update([
                'name' => $request->name,
                'image' => $category->image
            ]);
        }
        return redirect()->route('categories.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function destroy(Category $category)
    {
        $this->category->find($category->id)->delete(); 
        return redirect()->route('categories.index');
    }
    public function listSoftDelete()
    {
        $softCategories = $this->category->onlyTrashed()->get();
        return view('categories.list_softdelete')->with('softCategories', $softCategories);
    }
    public function restore($id)
    {
        $category = $this->category->onlyTrashed()->where('id', $id)->first();
        $category->restore();
        return redirect()->route('categories.index');
    }
    public function realDelete($id)
    {
        $user = $this->category->onlyTrashed()->where('id', $id)->first();
        unlink(public_path('uploads/'.$user->image));
        $user->ForceDelete();
        return redirect()->back()->with('success', 'Đã xóa user khỏi database ');
    }
}

resources/views/categories/createorupdate.blade.php
@extends('layouts.view_home')
@section('css')
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/dropzone/5.9.3/dropzone.min.css"
        integrity="sha512-jU/7UFiaW5UBGODEopEqnbIAHOI8fO6T99m7Tsmqs2gkdujByJfkCbbfPSN4Wlqlb9TGnsuC0YgUgWkRBK7B9A=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />
@endsection
@section('content')
    <div class="content-body" style="color: black">
        <div class="card-header">
            <h3 class="card-title" style="color: blue">Create Category</h3>
        </div>
        <div class="card">

            <div class="card-body">
                <form
                    action=" @if (isset($category->id)) {{ route('categories.update', $category->id) }} 
                    @else
                    {{ route('categories.store') }} @endif"
                    method="POST" enctype="multipart/form-data">
                    @csrf
                    @if (isset($category->id))
                        @method('PUT')
                    @endif

                    @include('components.input_sample', [
                        'name' => 'name',
                        'value' => $category->name ?? '',
                    ])

                    @include('components.input_image', ['value' => $category->image ?? ''])

                    <button type="submit" class="m btn btn-primary">Submit</button>
                </form>
            </div>

            <div class="card-footer clearfix">

            </div>
        </div>
    </div>
@endsection
@section('js')
    <script src="https://cdnjs.cloudflare.com/ajax/libs/dropzone/5.9.3/dropzone.min.js"
        integrity="sha512-U2WE1ktpMTuRBPoCFDzomoIorbOyUv0sP8B+INA3EzNAhehbzED1rOJg6bCqPf/Tuposxb5ja/MAUnC8THSbLQ=="
        crossorigin="anonymous" referrerpolicy="no-referrer"></script>
    {{-- <script type="text/javascript">
            Dropzone.autoDiscover = false;
        $(document).ready(function() {
            $("#imageUpload").Dropzone({
                Dropzone.autoDiscover = true;
                maxFilesize: 1,
                acceptedFiles: '.jpeg,.jpg,.png,.gif'
                maxFilesize: 2,
                uploadMultiple: false,
                addRemoveLinks: true,
                maxFiles: 1,
                autoProcessQueue: false

            })
        })
    </script> --}}
@endsection

resources/views/categories/index.blade.php
@extends('layouts.view_home')
@section('content')
    <div class="content-body">
        <div class="card-header">
            <h3 class="card-title" style="color: blue">Danh sách loại sản phẩm</h3>
        </div>
        <div class="card">
            <div class="card-body">

                <div class="p-2 bd-highlight">
                    <a href="{{ route('categories.create') }}" class="btn btn-success">Add</a>
                    <a class="btn btn-secondary" href="{{ route('list.categorysoftDelete') }}">Restore</a>
                </div>

                <table id="example2" class="table" style="color: black">
                    <thead>
                        @php
                            $i = 1;
                        @endphp
                        <tr>
                            <th>STT</th>
                            <th>Tên loại sản phẩm</th>
                            <th>Image</th>
                            <th style="width:20px;">Edit</th>
                            <th style="width:20px;">Delete</th>
                        </tr>
                    </thead>
                    @foreach ($categories as $category)
                        <tr>
                            <td>{{ $i++ }}</td>
                            <td>{{ $category->name }}</td>
                            <td><img style="height: 50px;width: 50px; " src="/uploads/{{ $category->image }}"></td>
                            <td style="width:20px;"><a class="btn btn-primary"
                                    href="{{ route('categories.edit', $category->id) }}">Edit</a></td>
                            <td style="width:20px;">
                                <form action="{{ route('categories.destroy', $category->id) }}" method="POST">
                                    @csrf
                                    @method('DELETE')
                                    <button type="submit" class="btn btn-danger">Delete</button>
                                </form>
                            </td>
                        </tr>
                    @endforeach
                    <tbody>
                </table>
            </div>
        </div>
    </div>
@endsection

resources/views/categories/list_softdelete.blade.php
@extends('layouts.view_home')
@section('content')
<div class="content-body">
        <div class="card-header">
            <h3 class="card-title" style="color: blue">Restore Category</h3>
        </div>
        <div class="card">
            <div class="card-body">
                <div class="p-2 bd-highlight"><a href="{{ route('categories.create') }}" class="btn btn-success">Add</a></div>
                {{-- <div class="p-2 bd-highlight">
                    <form action="" method="GET">
                        @csrf
                        <button class="btn btn-info" style="text-decoration: none; color: #ffff;" type="submit"
                            name="export_exel">Export excel</button>
                    </form>
                </div> --}}
                <table id="example2" class="table" style="color: black">
                    <thead>
                        @php
                            $i = 1;
                        @endphp
                        <tr>
                            <th>STT</th>
                            <th>Tên loại sản phẩm</th>
                            <th>Image</th>
                            <th style="width:20px;">Restore</th>
                            <th style="width:20px;">Delete</th>
                        </tr>
                    </thead>
                    @foreach ($softCategories as $softCategory)
                        <tr>
                        <td>{{$i++}}</td>
                        <td>{{$softCategory->name}}</td>
                        <td><img style="height: 50px;width: 50px; " src="/uploads/{{$softCategory->image}}"></td>
                        <td style="width:20px;"><a  class="btn btn-primary" href="{{route('category.restore',$softCategory->id)}}">Restore</a></td>
                        <td style="width:20px;"><form action="{{route('category.realDelete',$softCategory->id)}}" method="POST">
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="btn btn-danger">Delete</button>
                            </form></td>
                    </tr>
                    @endforeach
                    <tbody>
                </table>
            </div>
        </div>
    </div>
@endsection